#include <LiquidCrystal_I2C.h>

//LCD Screen
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,20,4);

//Motor Pins
const int motorJack = 9; //for the Jack Daniels motor
const int motorCoke = 8; //for the Coke motor

//Buttons
const int buttonLeft = 13; //button pin
const int buttonMiddle = 12;
const int buttonRight = 10;

//State & Button States
int State = 1;
int statePrev = 0; 
int buttonL = 0; //button state
int buttonM = 0;
int buttonR = 0;
int buttonStatePrevL = 0; //buttonstateprev
int buttonStatePrevM = 0;
int buttonStatePrevR = 0;

//Time
unsigned long changeTime = 0;

//Drink Time
unsigned long jackTime = 22000.0;
unsigned long cokeTime = 92000.0;


void setup() {
  
 //Input
 pinMode(buttonLeft, INPUT);
 pinMode(buttonMiddle, INPUT);
 pinMode(buttonRight, INPUT);
 
 //Output
 pinMode(motorJack, OUTPUT);
 pinMode(motorCoke, OUTPUT);

 //LCD 
 lcd.init();                       
 lcd.init();
 lcd.backlight();

changeTime = millis();
Serial.begin(9600); 
}

void loop() {
  //Button Setup

  buttonL = buttonStatePrevL;
  buttonStatePrevL = digitalRead(buttonLeft);
  
  buttonM = buttonStatePrevM;
  buttonStatePrevM = digitalRead(buttonMiddle);

  buttonR = buttonStatePrevR;
  buttonStatePrevR = digitalRead(buttonRight);

//STATE 1: Standard Drink?
switch (State) {
  case 1: 
  Serial.println(" State 1 ");
 
  lcd.setCursor(0,0);
  lcd.print("Standard Drink?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");

//YES  State 1 -> State 2
 if (buttonL == HIGH && buttonStatePrevL == LOW) {
  Serial.println(" button press detected "); 
  
  jackTime = 22000.0;
  cokeTime = 92000.0; 

  lcd.setCursor(0,0);
  lcd.print("Ready to Pour?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");

  statePrev = 1;
  State = 2;
 break; 
 }
 
//NO State 1 -> State 3
 if (buttonR == HIGH && buttonStatePrevR == LOW) {
  Serial.println(" button press detected ");

  lcd.setCursor(0,0); 
  lcd.print(" Quantity of X? ");
  lcd.setCursor(0,1);
  lcd.print("Yes?       Back?");
  
  statePrev = 1;
  State = 3;
 } break; 
  
//STATE 2: Are you Ready For your drink?
  case 2: 
  Serial.println(" in State 2 ");  
  //On screen: "Ready to Pour? "Yes? no?"

if (buttonL == HIGH && buttonStatePrevL == LOW) {
  Serial.println(" button press detected ");

  lcd.setCursor(0,0); 
  lcd.print("     Pouring    ");
  lcd.setCursor(0,1);
  lcd.print("     Cancel?    ");

  digitalWrite(motorJack, HIGH);
  digitalWrite(motorCoke, HIGH); 

  changeTime = millis();
  
  statePrev = 2;
  State = 11;
  break; 
} 

//State 2 -> 3 (change to 10 to select quantity of fluid)
if ((buttonR == HIGH && buttonStatePrevR == LOW) && (statePrev == 3)) {
  Serial.println(" button press detected "); 
  
  lcd.setCursor(0,0); 
  lcd.print(" Quantity of X? ");
  lcd.setCursor(0,1);
  lcd.print(" Yes?     Back? ");

  statePrev = 2;
  State = 3;  
  break; 
} 

//State 2 - > 1 (cancel selected & prevState = 1) 
if ((buttonR == HIGH && buttonStatePrevR == LOW) && (statePrev == 1)) {
  Serial.println(" button press detected "); 

  lcd.setCursor(0,0);
  lcd.print("Standard Drink?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");

  statePrev = 2;
  State = 1;  
} break; 
 
//STATE 3: Select Quantity of XXX? 
//On Screen: Quantity of X? Yes? No?
 case 3:
 Serial.println(" in State 3 ");
//Yes State 3 -> State 10
 if (buttonL == HIGH && buttonStatePrevL == LOW) {
  Serial.println( " button press detected ");

  lcd.setCursor(0,0);
  lcd.print("How much of X?");
  lcd.setCursor(0,1);
  lcd.print("Small? Med? Lrg?");

  statePrev = 3;
  State = 10;
  break; 
 }  
 
 //No? State 3 -> State 1
 if (buttonR == HIGH && buttonStatePrevR == LOW) {
  Serial.println(" button press detected ");
  
  lcd.setCursor(0,0);
  lcd.print("Standard Drink?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");

  statePrev = 3;
  State = 1;
 } break; 
 
//STATE 10: Fluid XXX
  // On screen: How much of X Small Medium Lrg? 
  case 10: 
  Serial.println(" in State 10 ");
  // Lo? Med? High? Buttons corresponding to changing Equation going to State 2
  
  //LOW
  if (buttonL == HIGH && buttonStatePrevL == LOW) {
  Serial.println(" SMALL Drink Selected (Button Pressed) ");
    
  jackTime = 15000.0;
  cokeTime = 100000.0;

  lcd.setCursor(0,0);
  lcd.print("Ready to Pour?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");
  
  State = 2;
  break; 
  }

  //MEDIUM
  if (buttonM == HIGH && buttonStatePrevM == LOW) {
  Serial.println(" MEDIUM Drink Selected (Button Pressed) "); 

  jackTime = 22000.0;
  cokeTime = 92000.0;
  
  lcd.setCursor(0,0);
  lcd.print("Ready to Pour?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");
  
  State = 2;
  break; 
 }
  //LARGE
  if (buttonR == HIGH && buttonStatePrevR == LOW) {
 Serial.println(" LARGE Drink Selected (Button Pressed) "); 

  jackTime = 35000.0;
  cokeTime = 78000.0;

  lcd.setCursor(0,0);
  lcd.print("Ready to Pour?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");
  
  State = 2;
  } break; 
   
//STATE 11: Pouring w/Cancel function (sets Motor pins = low)    
  case 11: 
  Serial.println(" in State 11 ");

  lcd.setCursor(0,0); 
  lcd.print("     Pouring    ");
  lcd.setCursor(0,1);
  lcd.print("     Cancel?    ");

//JACK SHUTOFF
  if (millis() - changeTime > jackTime) {
    
    digitalWrite(motorJack, LOW);
  }

//COKE SHUTOFF
  if (millis() - changeTime > cokeTime) {

  digitalWrite(motorCoke, LOW);

  lcd.setCursor(0,0);
  lcd.print("Standard Drink?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");

  State = 1; 
  break;
  } 

if ((buttonL == HIGH && buttonStatePrevL == LOW) || (buttonM == HIGH && buttonStatePrevM == LOW) || (buttonR == HIGH && buttonStatePrevR == LOW)) {
   Serial.println(" button press detected ");

  digitalWrite(motorJack, LOW);
  digitalWrite(motorCoke, LOW); 

  lcd.setCursor(0,0);
  lcd.print("    Operator    ");
  lcd.setCursor(0,1);
  lcd.print("      Error     ");
 
  delay(10000);

  lcd.setCursor(0,0);
  lcd.print("Standard Drink?");
  lcd.setCursor(0,1);
  lcd.print("Yes?         No?");
  
  State = 1; 
  break;
} 
break; 

}
}
